VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSplitterBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Control1 As Control ' Left control
Private Control2 As Control ' Right control
Private Splitter As Control ' Splitter control
Private Container As Control ' Containter control

Private nSplitterPosition As Single ' variable indicating
'the splitter bar's position

Public LastBarPosition As Single ' variable indicating
'the splitter bar's position,just before it is moved


Public Property Get BarPosition() As Single
   
   BarPosition = nSplitterPosition

End Property

'Initialize the class
Public Sub InitSplitter(ByRef C1 As Control, ByRef C2 As Control, ByRef S As Control, ByRef Cont As Control)

   On Error GoTo ErrorHandler
   
   'Check if the these are valid control variables
   If (Not (TypeOf C1 Is PictureBox) And Not (TypeOf C1 Is TextBox)) Or _
      (Not (TypeOf C2 Is PictureBox) And Not (TypeOf C2 Is TextBox)) Or _
      (Not (TypeOf S Is PictureBox)) Or _
      (Not (TypeOf Cont Is PictureBox)) Then _
      Err.Raise 514, , "The Container and Splitter controls can only be of class PictureBox," & vbCrLf & "while the other controls can be either PicturBox or TextBox"

   Set Control1 = C1
   Set Control2 = C2
   Set Splitter = S
   Set Container = Cont
   
   'Place the controls on the container control
   Set Control1.Container = Container
   Set Control2.Container = Container
   Set Splitter.Container = Container
      
   'These are not really needed,it's a design issue really
   Container.BorderStyle = 1
   Control1.BorderStyle = 1
   Control2.BorderStyle = 1
   Splitter.BorderStyle = 0
   
   'Place the splitter bar on the middle
   InitControls

ErrorHandler:

   Select Case Err
      Case 514
         MsgBox Err.Description, vbExclamation, "clsSplitterBar.InitSplitter Error"
   End Select

End Sub



Private Sub InitControls()

   'Place the splitter bar on the middle
   nSplitterPosition = Container.ScaleWidth / 2 - Splitter.Width / 2
   'Resize the controls
   ResizeControls

End Sub

Private Sub ResizeControls()
  
   DoEvents

   'This is where the controls are resized
   Splitter.Move nSplitterPosition, 0, Splitter.Width, Container.ScaleHeight
   Control1.Move 0, 0, Splitter.Left, Container.ScaleHeight
   Control2.Move Splitter.Left + Splitter.Width, 0, Container.ScaleWidth - (Splitter.Left + Splitter.Width), Container.ScaleHeight
   
End Sub

'This public procedure is called by the Form's module to indicate
'that the Splitter Bar has moved.
Public Sub MoveBar(Optional ByVal Dist As Single = 0)
   
   Dist = Dist - LastBarPosition
   
   If (nSplitterPosition + Dist < 0) Then Exit Sub
   If (nSplitterPosition + Dist + Splitter.Width) > Container.ScaleWidth Then Exit Sub
   
   nSplitterPosition = nSplitterPosition + Dist
   ResizeControls

End Sub


